unit recherche;
{
  Copyright (C) 2013-2021 Marc SERRAU

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}
{$MODE Delphi}

// unité locale au projet de création de l'index Tycho_xmatch et Hipparcos_xmatch et utilisé ailleurs pour GAIA
// Des aménagements l'ont légèrement modifiée : utilisation de key avec des QWord.
// tableau dynamique, T_key.
interface

type
   key = packed record
      rang : longint;
      value : QWord;
   end;
   T_key = ^key;
   T_Table = array of T_key;
   P_Table = ^T_Table;


function RechercheIndex(table : P_table; taille : longint; rech : QWord):longint;

implementation


function RechercheIndex(table : P_table; taille : longint; rech : QWord):longint;
var
   lim,i,anc,inf,sup  : longint;
   fin,trouve : boolean;
begin
   lim:=trunc(ln(taille)/ln(2));
   trouve:=false;
   fin:=false;
   anc:=trunc(taille/2);
   inf:=1;
   i:=0;
   sup:=taille+1;
   repeat
       if i>(lim+1) then fin:=true;
       if table^[anc]^.value=rech then
          trouve:=true
       else
       begin
          inc(i);
          if table^[anc]^.value > rech then
          begin
             sup:=anc;
             anc:=trunc((inf+anc)/2);
          end
          else
          begin
             inf:=anc;
             anc:=trunc((sup+anc)/2);
          end
       end
   until trouve or fin;
   if trouve then RechercheIndex:=table^[anc]^.rang else RechercheIndex:=0;
end;

end.
